/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G13 V2.03.03.03 [07 Mar 2016]
* Device(s)    : R5F100AD
* Tool-Chain   : CA78K0R
* Description  : This file implements main function.
* Creation Date: 2016/05/07
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_serial.h"
#include "r_cg_timer.h"
/* Start user code for include. Do not edit comment generated here */
#include    <string.h>
#include    <stdio.h>
#include    <stdlib.h>
#include "main.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
int iCountTimer = 0;
char switch16,switch1,switch2,switch3,switch4,switch5,switch6,switch7,switch8,switch9,switch10,switch11,switch12,switch13,switch14,switch15;
int switchRetuNew, switchRetuOld, switchRetu_UPEDGE, switchRetu_DOWNEDGE;
int keta1,keta2,keta3,keta4,keta5;
int keta1_old,keta2_old,keta3_old,keta4_old,keta5_old;

void fnGazou_save(void);
void fnMeasurement_Count(int count,int count2);
void fnGazou_Measurement(void);

/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
    fnLCDCInit();
    R_UART1_Start();
    R_TAU0_Channel0_Start(); //^C}ACjbg0(C^[o^C})Jn
    
    fnLCDC_RTSset(1);       //RTSgp(1)  M(1)

    fnLCDCt(0); //_~[t0𑗂B̃R}ĥ͖߂ɑMA葤̎M𐮂ÃR}hmɎ󂯎点B
    fnLCDCt(t_mode);        //tR}hŃ^b`plf[^擾[h߂B
    
    fnLCDCR(R_mode);      //MR}h̗L߂B
    
    fnLCDC_RTSset(0);       //RTS𖳎(0)  M(1)

    while (1U)
    {
	fnGazou_Measurement();
    }
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */
    EI();
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/*****************************
    ֐Fasctoi
    F|C^z
    ߂lFPOi

    ASCUR[h̐APOiɒB
******************************/
short asctoi(char *ptr)
{
    unsigned short v;

    for(v=0;(*ptr >= '0' && *ptr <= '9')||(*(ptr) >= 'A' && *(ptr) <= 'F')||(*(ptr) >= 'a' && *(ptr) <= 'f');ptr++){
        if(*(ptr) >= '0' && *(ptr) <= '9') v = v*0x10+(*ptr-0x30);
        else if(*(ptr) >= 'A' && *(ptr) <= 'F') v = v*0x10+(*ptr-0x37);
        else if(*(ptr) >= 'a' && *(ptr) <= 'f') v = v*0x10+(*ptr-0x57);
    }
    return v;
}

void fnMeasurement_Count(int count,int count2){

    keta3 = count%10;
    keta4 = (count/10)%10;
    keta5 = (count/100)%10;


    fnLCDCP(0,L_NUN3_X,L_NUN_Y,20+keta5);
    fnLCDCP(0,L_NUN2_X,L_NUN_Y,20+keta4);
    fnLCDCP(0,L_NUN1_X,L_NUN_Y,20+keta3);
    fnLCDCP(0,M_NUN2_X,M_NUN_Y,30+count2);  //_ȉ1
    fnLCDCP(0,M_NUN1_X,M_NUN_Y,30+count2);  //_ȉ2

}

void fnGazou_Measurement(void){
    char sw4_data;
    int countgo_flag,count,count2,c;

//wi`
fnLCDCP(0,000,000,1);


//OOODOO\

fnMeasurement_Count(0,0);
fnLCDCP(1,M_NUN3_X,M_NUN_Y,52);  //_

//̌̒Pʂ\
fnLCDCP(0,UNIT_X,UNIT_Y,58);  //Pʕ\

//3̃{^\
fnLCDCP(0,MENU_X,MENU_Y,14);    //MENU\
fnLCDCP(0,START_X,START_Y,16);  //START\
fnLCDCP(0,STOP_X,STOP_Y,18);  //STOP\
//PʕύXp̏㑤6{^\
fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);       //V
fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);     //mV
fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);     //A
fnLCDCP(0,UNITSW4_X,UNITSW_Y,11);    //mA͉Ă摜\
fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);     //kg
fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);     //g

//HI̐l
fnLCDCP(0,56,58,41);    //1
fnLCDCP(0,76,58,47);    //7
fnLCDCP(0,96,58,40);    //0
fnLCDCP(0,116,58,54);   //_
fnLCDCP(0,136,58,40);   //0
fnLCDCP(0,156,58,40);   //0

//LO̐l
fnLCDCP(0,344,58,40);   //0
fnLCDCP(0,364,58,44);   //4
fnLCDCP(0,384,58,40);   //0
fnLCDCP(0,404,58,54);   //_
fnLCDCP(0,424,58,40);   //0
fnLCDCP(0,444,58,40);   //0

//gpϐ̏
    sw4_data = 0;    
    count =0;
    count2 = 0;
    countgo_flag = 0;
    
    keta1 = 0;
    keta2 = 0;
    keta3 = 0;
    keta4 = 0;
    keta5 = 0;
    
    keta1_old = 0;
    keta2_old = 0;
    keta3_old = 0;
    keta4_old = 0;
    keta5_old = 0;
    
    
//[vJn
    while(1){
        //wW̊m
        fnSerial_Decision();        //[vJnŃX}[gLCDC̃R}h͂B

        //ʂɍ쐬XCb`̊mF
        //XCb`1̔f
        if((usLCDCuiX >= 20) & (usLCDCuiX <= 150) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
            switch1 = 1;
        }else{
            switch1 = 0;
        }
        //XCb`2̔f
        if((usLCDCuiX >= 170) & (usLCDCuiX <= 310) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
           switch2 = 1;
        }else{
           switch2 = 0;
        }        
        
        //XCb`3̔f
        if((usLCDCuiX >= 330) & (usLCDCuiX <= 460) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
           switch3 = 1;
        }else{
           switch3 = 0;
        }
        
        //XCb`4̔f
        if(countgo_flag == 0){
            if((usLCDCuiX >= 1) & (usLCDCuiX <= 479) & (usLCDCuiY >= 1) & (usLCDCuiY <= 60)){
                if((usLCDCuiX >= 1) & (usLCDCuiX <= 79)){
                    sw4_data = 1;
                }
                if((usLCDCuiX >= 80) & (usLCDCuiX <= 159)){
                    sw4_data = 2;
                }
                if((usLCDCuiX >= 160) & (usLCDCuiX <= 239)){
                    sw4_data = 3;    
                }
                if((usLCDCuiX >= 240) & (usLCDCuiX <= 319)){
                    sw4_data = 4;
                }
                if((usLCDCuiX >= 320) & (usLCDCuiX <= 399)){
                    sw4_data = 5;                
                }
                if((usLCDCuiX >= 400) & (usLCDCuiX <= 479)){
                    sw4_data = 6;
                } 
                switch4 = 1;
            }else{
                switch4 = 0;
            }
        }
        
        
        switchRetuOld = switchRetuNew;  //ÕXCb`̏ԂێB
        switchRetuNew = (switch1 | switch2<<1 | switch3<<2 | switch4<<3 | switch5<<4 | switch6<<5 | switch7<<6 | switch8<<7 | switch9<<8 | switch10<<9 | switch11<<10 | switch12<<11 | switch13<<12 | switch14<<13 | switch15<<14 | switch16<<15);

        switchRetu_UPEDGE = ((switchRetuOld | switchRetuNew)^switchRetuOld);//オ莞
        switchRetu_DOWNEDGE = ((switchRetuOld | switchRetuNew)^switchRetuNew);//莞
        
        
        if(countgo_flag == 0){
            //JEgAbṽtOĂƂXCb`𔽉ꏊ
            if(switchRetu_UPEDGE & SWITCH1_UP){     //1オGbWo
                fnLCDCP(0,MENU_X,MENU_Y,15);    //MENU\
            }
           
            if(switchRetu_DOWNEDGE & SWITCH1_UP){   //1GbWo
                fnLCDCP(0,MENU_X,MENU_Y,14);    //MENU\

                switchRetu_DOWNEDGE= 0x0000;
                return;     //̊֐𔲂A߂̃j[ʂ
            }

        
            if(switchRetu_UPEDGE & SWITCH2_UP){     //2オGbWo
                if(countgo_flag == 0){
                    fnLCDCP(0,START_X,START_Y,17);    //START\  Ă
                }
            }
        
            if(switchRetu_DOWNEDGE & SWITCH2_UP){   //2GbWo
                fnLCDCP(0,START_X,START_Y,16);    //START\  
                //OOO.OO\            
                fnMeasurement_Count(0,0);

                count = 0;
                countgo_flag = 1;
            }
            
            if(switchRetu_UPEDGE & SWITCH4_UP){     //4オGbWo
                if(sw4_data == 1){
                    fnLCDCP(0,UNITSW1_X,UNITSW_Y,13);   //V Ă摜ɂB
                    fnLCDCP(0,UNIT_X,UNIT_Y,60);  //_2ʂ̌̒PʕύX
                    
                    fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);    //mV
                    fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);    //A
                    fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);    //mA
                    fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);    //kg
                    fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);    //g
                    
                }
                if(sw4_data == 2){
                    fnLCDCP(0,UNITSW2_X,UNITSW_Y,12);     //mVĂ摜ɂB 
                    fnLCDCP(0,UNIT_X,UNIT_Y,59);  //_2ʂ̌̒PʕύX

                    fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);                    
                    fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);
                    fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);
                    fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);
                    fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);
                }
                if(sw4_data == 3){
                    fnLCDCP(0,UNITSW3_X,UNITSW_Y,8);     //AĂ摜ɂB
                    fnLCDCP(0,UNIT_X,UNIT_Y,55);  //_2ʂ̌̒PʕύX

                    fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);                    
                    fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);
                    fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);
                    fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);
                    fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);
                }
                if(sw4_data == 4){
                    fnLCDCP(0,UNITSW4_X,UNITSW_Y,11);     //mAĂ摜ɂB
                    fnLCDCP(0,UNIT_X,UNIT_Y,58);  //_2ʂ̌̒PʕύX

                    fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);                    
                    fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);
                    fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);
                    fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);
                    fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);
                }
                if(sw4_data == 5){
                    fnLCDCP(0,UNITSW5_X,UNITSW_Y,10);     //kgĂ摜ɂB
                    fnLCDCP(0,UNIT_X,UNIT_Y,57);  //_2ʂ̌̒PʕύX

                    fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);                    
                    fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);
                    fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);
                    fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);
                    fnLCDCP(0,UNITSW6_X,UNITSW_Y,3);
                }
                if(sw4_data == 6){
                    fnLCDCP(0,UNITSW6_X,UNITSW_Y,9);     //gĂ摜ɂB
                    fnLCDCP(0,UNIT_X,UNIT_Y,56);  //_2ʂ̌̒PʕύX

                    fnLCDCP(0,UNITSW1_X,UNITSW_Y,7);                    
                    fnLCDCP(0,UNITSW2_X,UNITSW_Y,6);
                    fnLCDCP(0,UNITSW3_X,UNITSW_Y,2);
                    fnLCDCP(0,UNITSW4_X,UNITSW_Y,5);
                    fnLCDCP(0,UNITSW5_X,UNITSW_Y,4);
                }
            }
        }
                
        
        if(switchRetu_UPEDGE & SWITCH3_UP){     //3オGbWo
            countgo_flag = 0;
            fnLCDCP(0,STOP_X,STOP_Y,19);    //STOP\
        }
        if(switchRetu_DOWNEDGE & SWITCH3_UP){   //3GbWo
            fnLCDCP(0,STOP_X,STOP_Y,18);    //STOP\
        }
        
        //////////////////////////////////////////////////////////////////////////////////////////////////////////////////
        if(countgo_flag == 1){
            if(iCountTimer == 0){       //^C}[肽ꍇ͂폜
                iCountTimer = 30;       //̓^C}[̒ 
                fnMeasurement_Count(count,count2);
                count++;
                count2++;
                if(count2 == 10){
                    count2 = 0;
                }                       
            }                           //^C}[Œǉ̂
            
        
            if(count >= 225){
                fnMeasurement_Count(count,count2);
                fnLCDCP(0,M_NUN2_X,M_NUN_Y,32);  //_Pʂ2\
                fnLCDCP(0,M_NUN1_X,M_NUN_Y,30);  //_Qʂ0\
                fnSerial_Decision();
                if((usLCDCuiX >= 330) & (usLCDCuiX <= 460) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
                    countgo_flag = 0;
                    goto OUT;
                }
                fnLCDCP(0,M_NUN1_X,M_NUN_Y,31);  //_Qʂ1\
                fnSerial_Decision();
                if((usLCDCuiX >= 330) & (usLCDCuiX <= 460) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
                    countgo_flag = 0;
                    goto OUT;
                }
                fnLCDCP(0,M_NUN1_X,M_NUN_Y,32);  //_Qʂ2\
                fnSerial_Decision();
                if((usLCDCuiX >= 330) & (usLCDCuiX <= 460) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
                    countgo_flag = 0;
                    goto OUT;
                }
                fnLCDCP(0,M_NUN1_X,M_NUN_Y,33);  //_Qʂ3\
                fnSerial_Decision();
                if((usLCDCuiX >= 330) & (usLCDCuiX <= 460) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
                    countgo_flag = 0;
                    goto OUT;
                }
                fnLCDCP(0,M_NUN1_X,M_NUN_Y,34);  //_Qʂ4\
                fnSerial_Decision();
                if((usLCDCuiX >= 330) & (usLCDCuiX <= 460) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
                    countgo_flag = 0;
                    goto OUT;
                }
                fnLCDCP(0,M_NUN1_X,M_NUN_Y,35);  //_Qʂ5\
                fnSerial_Decision();
                if((usLCDCuiX >= 330) & (usLCDCuiX <= 460) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
                    countgo_flag = 0;
                    goto OUT;
                }
                fnLCDCP(0,M_NUN1_X,M_NUN_Y,36);  //_Qʂ6\
                fnSerial_Decision();
                if((usLCDCuiX >= 330) & (usLCDCuiX <= 460) & (usLCDCuiY >= 200) & (usLCDCuiY <= 260)){
                    countgo_flag = 0;
                    goto OUT;
                }
                fnLCDCP(0,M_NUN1_X,M_NUN_Y,37);  //_Qʂ7\


                countgo_flag = 0;
            }
            OUT:
	    ;
        }
    }
}
/* End user code. Do not edit comment generated here */
