/***********************************************************************************************************************
* DISCLAIMER
* This software is supplied by Renesas Electronics Corporation and is only intended for use with Renesas products.
* No other uses are authorized. This software is owned by Renesas Electronics Corporation and is protected under all
* applicable laws, including copyright laws. 
* THIS SOFTWARE IS PROVIDED "AS IS" AND RENESAS MAKES NO WARRANTIESREGARDING THIS SOFTWARE, WHETHER EXPRESS, IMPLIED
* OR STATUTORY, INCLUDING BUT NOT LIMITED TO WARRANTIES OF MERCHANTABILITY, FITNESS FOR A PARTICULAR PURPOSE AND
* NON-INFRINGEMENT.  ALL SUCH WARRANTIES ARE EXPRESSLY DISCLAIMED.TO THE MAXIMUM EXTENT PERMITTED NOT PROHIBITED BY
* LAW, NEITHER RENESAS ELECTRONICS CORPORATION NOR ANY OF ITS AFFILIATED COMPANIES SHALL BE LIABLE FOR ANY DIRECT,
* INDIRECT, SPECIAL, INCIDENTAL OR CONSEQUENTIAL DAMAGES FOR ANY REASON RELATED TO THIS SOFTWARE, EVEN IF RENESAS OR
* ITS AFFILIATES HAVE BEEN ADVISED OF THE POSSIBILITY OF SUCH DAMAGES.
* Renesas reserves the right, without notice, to make changes to this software and to discontinue the availability 
* of this software. By using this software, you agree to the additional terms and conditions found by accessing the 
* following link:
* http://www.renesas.com/disclaimer
*
* Copyright (C) 2011, 2016 Renesas Electronics Corporation. All rights reserved.
***********************************************************************************************************************/

/***********************************************************************************************************************
* File Name    : r_main.c
* Version      : CodeGenerator for RL78/G13 V2.03.03.03 [07 Mar 2016]
* Device(s)    : R5F100AD
* Tool-Chain   : CA78K0R
* Description  : This file implements main function.
* Creation Date: 2016/05/07
***********************************************************************************************************************/

/***********************************************************************************************************************
Pragma directive
***********************************************************************************************************************/
/* Start user code for pragma. Do not edit comment generated here */
/* End user code. Do not edit comment generated here */

/***********************************************************************************************************************
Includes
***********************************************************************************************************************/
#include "r_cg_macrodriver.h"
#include "r_cg_cgc.h"
#include "r_cg_port.h"
#include "r_cg_serial.h"
#include "r_cg_timer.h"
/* Start user code for include. Do not edit comment generated here */
#include    <string.h>
#include    <stdio.h>
#include    <stdlib.h>
#include "main.h"
/* End user code. Do not edit comment generated here */
#include "r_cg_userdefine.h"

/***********************************************************************************************************************
Global variables and functions
***********************************************************************************************************************/
/* Start user code for global. Do not edit comment generated here */
int iCountTimer = 0;
int keta1,keta2,keta3,keta4,keta5;

void fnGazou_Measurement(void);
/* End user code. Do not edit comment generated here */
void R_MAIN_UserInit(void);

/***********************************************************************************************************************
* Function Name: main
* Description  : This function implements main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void main(void)
{
    
    R_MAIN_UserInit();
    /* Start user code. Do not edit comment generated here */
    fnLCDCInit();
    R_UART1_Start();
    R_TAU0_Channel0_Start(); //^C}ACjbg0(C^[o^C})Jn
    
    fnLCDC_RTSset(1);       //RTSgp(1)  M(1)

    fnLCDCt(0); //_~[t0𑗂B̃R}ĥ͖߂ɑMA葤̎M𐮂ÃR}hmɎ󂯎点B    
    
    fnGazou_Measurement();
    
    while (1U)
    {
	;
    }
    /* End user code. Do not edit comment generated here */
}

/***********************************************************************************************************************
* Function Name: R_MAIN_UserInit
* Description  : This function adds user code before implementing main function.
* Arguments    : None
* Return Value : None
***********************************************************************************************************************/
void R_MAIN_UserInit(void)
{
    /* Start user code. Do not edit comment generated here */
    EI();
    /* End user code. Do not edit comment generated here */
}

/* Start user code for adding. Do not edit comment generated here */
/*****************************
    ֐Fasctoi
    F|C^z
    ߂lFPOi

    ASCUR[h̐APOiɒB
******************************/
short asctoi(char *ptr)
{
    unsigned short v;

    for(v=0;(*ptr >= '0' && *ptr <= '9')||(*(ptr) >= 'A' && *(ptr) <= 'F')||(*(ptr) >= 'a' && *(ptr) <= 'f');ptr++){
        if(*(ptr) >= '0' && *(ptr) <= '9') v = v*0x10+(*ptr-0x30);
        else if(*(ptr) >= 'A' && *(ptr) <= 'F') v = v*0x10+(*ptr-0x37);
        else if(*(ptr) >= 'a' && *(ptr) <= 'f') v = v*0x10+(*ptr-0x57);
    }
    return v;
}


void fnMeasurement_Count(int count,int count2){

    keta3 = count%10;
    keta4 = (count/10)%10;
    keta5 = (count/100)%10;


    fnLCDCP(0,L_NUN3_X,L_NUN_Y,20+keta5);
    fnLCDCP(0,L_NUN2_X,L_NUN_Y,20+keta4);
    fnLCDCP(0,L_NUN1_X,L_NUN_Y,20+keta3);
    fnLCDCP(0,M_NUN2_X,M_NUN_Y,30+count2);  //_ȉ1
    fnLCDCP(0,M_NUN1_X,M_NUN_Y,30+count2);  //_ȉ2

}

void fnGazou_Measurement(void){
    char sw4_data;
    int countgo_flag,count,count2,c;

//wi`
fnLCDCP(0,000,000,1);


//OOODOO\

fnMeasurement_Count(0,0);
fnLCDCP(1,M_NUN3_X,M_NUN_Y,52);  //_

//̌̒Pʂ\
fnLCDCP(0,UNIT_X,UNIT_Y,58);  //Pʕ\(mA)

//HI̐l
fnLCDCP(0,56,58,41);    //1
fnLCDCP(0,76,58,47);    //7
fnLCDCP(0,96,58,40);    //0
fnLCDCP(0,116,58,54);   //_
fnLCDCP(0,136,58,40);   //0
fnLCDCP(0,156,58,40);   //0

//LO̐l
fnLCDCP(0,344,58,40);   //0
fnLCDCP(0,364,58,44);   //4
fnLCDCP(0,384,58,40);   //0
fnLCDCP(0,404,58,54);   //_
fnLCDCP(0,424,58,40);   //0
fnLCDCP(0,444,58,40);   //0

//------------------
}
/* End user code. Do not edit comment generated here */
